if (typeof Norriq === 'undefined') {
    Norriq = {
        __namespace: true
    };
}
Norriq.QueryHelper = (function () {

    function prepareParameters(parameters) {
        return btoa(JSON.stringify(parameters));
    }
    return {
        UpdateObject: function(entityName, entityId, entity, callback) {
            // MSFT Logic
            console.log('Updating object');        
            (function(webapi, $){
                function safeAjax(ajaxOptions) {
                    var deferredAjax = $.Deferred();
            
                    shell.getTokenDeferred().done(function (token) {
                        // add headers for AJAX
                        if (!ajaxOptions.headers) {
                            $.extend(ajaxOptions, {
                                headers: {
                                    "__RequestVerificationToken": token
                                }
                            }); 
                        } else {
                            ajaxOptions.headers["__RequestVerificationToken"] = token;
                        }
                        $.ajax(ajaxOptions)
                            .done(function(data, textStatus, jqXHR) {
                                validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                            }).fail(deferredAjax.reject); //AJAX
                    }).fail(function () {
                        deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
                    });
            
                    return deferredAjax.promise();	
                }
                webapi.safeAjax = safeAjax;
            })(window.webapi = window.webapi || {}, jQuery);

            var url = '/_api/' + entityName + '(' + entityId + ')';
            webapi.safeAjax({
                type: "PATCH",
                url: "/_api/"+entityName+'('+entityId+')',
                contentType: "application/json",
                data: JSON.stringify(entity),
                success: function (res) {
                    console.log(res);
                    callback();
                }
            });
        },
        ExecuteWorkflow(entityname, entityid, workflowid, success, error) {
            var u = siteMarkers.ExecuteWorkflow;
            var params = {};
            var workflow = {};

            workflow.LogicalName = 'workflow';
            workflow.Id = workflowid;
            var data = {};
            data.LogicalName = entityname;
            data.Id = entityid;
            params.workflow = workflow;
            params.entity = data;
            var jData = JSON.stringify(params);
            shell.ajaxSafePost({
                type: "POST",
                contentType: "application/json",
                url: u,
                data: jData
            }).done(function (r) {
                    success(r);
                }).fail(function (n) {
                    error(n);
            }); 
        }
    };
})();